<?php

	if ( ! function_exists( 'zleadscrm_update_user_analytics' ) ) {
		function zleadscrm_update_user_analytics( $analytics ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$user_id   = $analytics['user_id'];
			$timestamp = current_time( 'Y-m-d' );

			$result = $wpdb->get_results( "SELECT * FROM $table_name WHERE user_id=$user_id AND timestamp='$timestamp' ORDER BY timestamp DESC LIMIT 1;" );

			if ( count( $result ) != 0 ) {
				$current_basic_requests    = $result[0]->basic_requests;
				$current_basic_results     = $result[0]->basic_results;
				$current_advanced_requests = $result[0]->advanced_requests;
				$current_advanced_results  = $result[0]->advanced_results;
				$result_id                 = $result[0]->id;

				$updated_basic_requests    = $current_basic_requests + $analytics['basic_requests'];
				$updated_basic_results     = $current_basic_results + $analytics['basic_results'];
				$updated_advanced_requests = $current_advanced_requests + $analytics['advanced_requests'];
				$updated_advanced_results  = $current_advanced_results + $analytics['advanced_results'];

				$wpdb->update( $table_name, array(
					'user_id'           => $user_id,
					'basic_requests'    => $updated_basic_requests,
					'basic_results'     => $updated_basic_results,
					'advanced_requests' => $updated_advanced_requests,
					'advanced_results'  => $updated_advanced_results,
					'timestamp'         => current_time( 'Y-m-d' )
				), array(
					'user_id' => $user_id,
					'id'      => $result_id
				) );

			} else {
				$wpdb->insert( $table_name, array(
					'user_id'           => $user_id,
					'basic_requests'    => $analytics['basic_requests'],
					'basic_results'     => $analytics['basic_results'],
					'advanced_requests' => $analytics['advanced_requests'],
					'advanced_results'  => $analytics['advanced_results'],
					'timestamp'         => current_time( 'Y-m-d' )
				) );
			}
		}
	}

	if ( ! function_exists( 'zleadscrm_get_advanced_request_this_week' ) ) {
		function zleadscrm_get_advanced_request_this_week( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$day        = date( 'w' );
			$week_start = date( 'Y-m-d 00:00:00', strtotime( '-' . $day . ' days' ) );
			$week_end   = date( 'Y-m-d 23:59:59', strtotime( '+' . ( 6 - $day ) . ' days' ) );

			$result = $wpdb->get_results( "SELECT SUM(advanced_requests) AS advanced_requests FROM $table_name WHERE timestamp<='$week_end' AND timestamp>='$week_start' AND user_id=$user_id;" );

			return isset( $result[0]->advanced_requests ) ? $result[0]->advanced_requests : 0;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_advanced_request_this_month' ) ) {
		function zleadscrm_get_advanced_request_this_month( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$month_start = date( 'Y-m-01 00:00:00' );
			$month_end   = date( 'Y-m-d 23:59:59', strtotime( 'last day of this month' ) );


			$result = $wpdb->get_results( "SELECT SUM(advanced_requests) AS advanced_requests FROM $table_name WHERE timestamp<='$month_end' AND timestamp>='$month_start' AND user_id=$user_id;" );

			return isset( $result[0]->advanced_requests ) ? $result[0]->advanced_requests : 0;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_request_this_week' ) ) {
		function zleadscrm_get_basic_request_this_week( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$day        = date( 'w' );
			$week_start = date( 'Y-m-d 00:00:00', strtotime( '-' . $day . ' days' ) );
			$week_end   = date( 'Y-m-d 23:59:59', strtotime( '+' . ( 6 - $day ) . ' days' ) );

			$result = $wpdb->get_results( "SELECT SUM(basic_requests) AS basic_requests FROM $table_name WHERE timestamp<='$week_end' AND timestamp>='$week_start' AND user_id=$user_id;" );

			return isset( $result[0]->basic_requests ) ? $result[0]->basic_requests : 0;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_request_this_month' ) ) {
		function zleadscrm_get_basic_request_this_month( $user_id ) {
			global $wpdb;
			$table_name = $wpdb->prefix . 'zleadscrm_leads_user_analytics';

			$month_start = date( 'Y-m-01 00:00:00' );
			$month_end   = date( 'Y-m-d 23:59:59', strtotime( 'last day of this month' ) );


			$result = $wpdb->get_results( "SELECT SUM(basic_requests) AS basic_requests FROM $table_name WHERE timestamp<='$month_end' AND timestamp>='$month_start' AND user_id=$user_id;" );

			return isset( $result[0]->basic_requests ) ? $result[0]->basic_requests : 0;
		}
	}

	if ( ! function_exists( 'zleadscrm_get_week_limit_type' ) ) {
		function zleadscrm_get_week_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_week_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_month_limit_type' ) ) {
		function zleadscrm_get_month_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_month_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_week_limit_type' ) ) {
		function zleadscrm_get_basic_week_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_basic_week_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}

	if ( ! function_exists( 'zleadscrm_get_basic_month_limit_type' ) ) {
		function zleadscrm_get_basic_month_limit_type( $user_id ) {
			$type = get_user_meta( $user_id, 'zleadscrm_basic_month_limit_type', true );

			if ( $type != '' ) {
				return $type;
			}

			return 'custom';
		}
	}
